# TPK4186 - Advanced Tools for Performance Engineering
# Binomial.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

# Factorial
def Factorial(n):
  product = 1
  for i in range(2, n+1):
    product = product*i
  return product

# Direct version
def BinomialWithFactorial(n, p):
  return Factorial(n) // (Factorial(p)*Factorial(n-p))

print("Binomial(10, 4) = " + str(BinomialWithFactorial(10, 4)))

# Recursive version
def BinomialRecursive(n, p):
  if p<=0 or p>=n:
    return 1
  return BinomialRecursive(n-1,p-1) + BinomialRecursive(n-1,p)

# Test
print("Binomial(10, 4) = " + str(BinomialRecursive(10, 4)))

