# TPK4186 - Advanced Tools for Performance Engineering
# SimplePendulum.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

import math

g = 9.81            # Gravity
L = 1.0             # Length of the cord
theta = 2.0*math.pi/3.0  # Angle from vertical
thetaDot = 0.0      # Velocity
thetaDotDot = 0.0   # Accelleration
dt = 0.01           # Time step
t = 0.0             # Time

while t<100:
    # Calculate acceleration due to gravity
    thetaDotDot = -(g/L) * math.sin(theta)
    # Change velocity according to accelleration
    thetaDot += thetaDotDot * dt
    # Change angle according to (updated) velocity
    theta += thetaDot * dt
    # Change position according to (updated) velocity
    x = L*math.sin(theta)
    y = -L*math.cos(theta)
    print(str(x) + "\t" + str(y))
    t = t+dt
